var hue;
var picker;
var gLogger;
var ID;

function init() {
	if (typeof(ygLogger) != "undefined") {
		ygLogger.init(document.getElementById("logDiv"));
		gLogger = new ygLogger("slider.php");
	}

	pickerInit();
}

// Picker ---------------------------------------------------------

function pickerInit() {
	hue = YAHOO.widget.Slider.getVertSlider("hueBg", "hueThumb", 0, 180);
	hue.onChange = function(newVal) { hueUpdate(newVal); };

	picker = YAHOO.widget.Slider.getSliderRegion("pickerDiv", "selector",
			0, 180, 0, 180);
	picker.onChange = function(newX, newY) { pickerUpdate(newX, newY); };

	hueUpdate();

	dd1 = new YAHOO.util.DD("pickerPanel");
	dd1.setHandleElId("pickerHandle");
	dd1.startDrag = function(e) {
		document.getElementById("DivShim").style.left = 0;
		document.getElementById("DivShim").style.top = -250;
	};
	dd1.endDrag = function(e) {
		document.getElementById("DivShim").style.left = (parseInt(document.getElementById("pickerPanel").style.left) + 4) + "px";
		document.getElementById("DivShim").style.top = (parseInt(document.getElementById("pickerPanel").style.top) + 4) + "px";
	};
}

window.onload = init;

function pickerUpdate(newX, newY) {
	pickerSwatchUpdate();
}

function hueUpdate(newVal) {
	
	var h = (180 - hue.getValue()) / 180;
	if (h == 1) { h = 0; }

	gLogger.debug("hue " + hue.getValue());

	var a = YAHOO.util.Color.hsv2rgb( h, 1, 1);

	document.getElementById("pickerDiv").style.backgroundColor =
		"rgb(" + a[0] + ", " + a[1] + ", " + a[2] + ")";

	pickerSwatchUpdate();
}

function pickerSwatchUpdate() {
	var h = (180 - hue.getValue());
	if (h == 180) { h = 0; }
	document.getElementById("pickerhval").value = (h*2);

	h = h / 180;
	gLogger.debug("h " + hue.getValue());

	var s = picker.getXValue() / 180;
	document.getElementById("pickersval").value = Math.round(s * 100);

	gLogger.debug("s " + s);

	var v = (180 - picker.getYValue()) / 180;
	document.getElementById("pickervval").value = Math.round(v * 100);

	gLogger.debug("v " + v);

	var a = YAHOO.util.Color.hsv2rgb( h, s, v );

	document.getElementById("pickerSwatch").style.backgroundColor =
		"rgb(" + a[0] + ", " + a[1] + ", " + a[2] + ")";

	document.getElementById("pickerrval").value = a[0];
	document.getElementById("pickergval").value = a[1];
	document.getElementById("pickerbval").value = a[2];
	document.getElementById("pickerhexval").value =
	YAHOO.util.Color.rgb2hex(a[0], a[1], a[2]);
}

function rgb2hsv(R,G,B) {
	R = ( R / 255 )
	G = ( G / 255 )
	B = ( B / 255 )
	H=0;
	S=0;
	V=0;
	
	MAX = Math.max(R,G,B);
	MIN = Math.min(R,G,B);
	
	if (MAX == MIN)
		return [0,0,Math.round(MAX * 100)];
	
	if (MAX == 0)
		return[0,0,0];
	
	S = (MAX-MIN) * 100 / MAX ;
	V = MAX * 100;
	
	if (MAX == R && G>=B)
		H = 60 * (G-B)/(MAX-MIN);
	
	if (MAX == R && G<B)
		H = 60 * (G-B)/(MAX-MIN) + 360;
		
	if (MAX == G)
		H = 60 * (B-R)/(MAX-MIN) + 120;
		
	if (MAX == B)
		H = 60 * (R-G)/(MAX-MIN) + 240;
	
	return [Math.round(H),Math.round(S),Math.round(V)]
}

function showColorPicker(event,id) {
	ID = id;
	
	color = document.getElementById("div_"+ID).style.backgroundColor;
	
	if (color.indexOf("rgb(")!=-1) {
		color = color.replace("rgb(","");
		color = color.replace(")","");
		rgb = color.split(",");
	}
	else {
		document.getElementById("pickerhexval").value = color.replace('#','');
		rgb = YAHOO.util.Color.hex2rgb(document.getElementById("pickerhexval").value);
	}
	
	document.getElementById("pickerrval").value = rgb[0];
	document.getElementById("pickergval").value = rgb[1];
	document.getElementById("pickerbval").value = rgb[2];
	hsv = rgb2hsv(rgb[0],rgb[1],rgb[2]);
	document.getElementById("pickerhval").value = hsv[0];
	document.getElementById("pickersval").value = hsv[1];
	document.getElementById("pickervval").value = hsv[2];

	LEFT = event.clientX + document.body.scrollLeft;
	TOP = event.clientY + document.body.scrollTop;
	
	if (window.innerWidth) {
		MAXLEFT = window.innerWidth
		MAXTOP = window.innerHeight
	}
	else {
		MAXLEFT = document.body.scrollWidth
		MAXTOP = document.body.scrollHeight
	}
	
	if (LEFT + 350 > MAXLEFT)
		LEFT = LEFT - 360;
		
	if (TOP + 230 > MAXTOP)
		TOP = TOP - 240;
	
	//reset
	hue.setValue(0,true);
	picker.setRegionValue(0,0,true);
	
	//load values
	hueVal = (360 - hsv[0])/2;
	if (hsv[0] == 0) hueVal = 0;
	hue.setValue(hueVal,true);
	picker.setRegionValue(hsv[1]*1.8,180-hsv[2]*1.8,true);
	
	
	document.getElementById("pickerPanel").style.position="absolute";
	document.getElementById("pickerPanel").style.left = LEFT;
	document.getElementById("pickerPanel").style.top = TOP;
	document.getElementById("pickerPanel").style.zIndex = 1000; 
	
	document.getElementById("DivShim").style.left = LEFT+4;
	document.getElementById("DivShim").style.top = TOP+4;
	document.getElementById("DivShim").style.zIndex = document.getElementById("pickerPanel").style.zIndex - 1; 
}

function hideColorPicker() {
	document.getElementById("pickerPanel").style.position="absolute";
	document.getElementById("pickerPanel").style.left=0;
	document.getElementById("pickerPanel").style.top=-250;
	document.getElementById("DivShim").style.left = 0;
	document.getElementById("DivShim").style.top = -250;
}

function saveColorPicker() {
	document.getElementById(ID).value = "#" + document.getElementById("pickerhexval").value;
	document.getElementById("div_"+ID).style.backgroundColor = "#" + document.getElementById("pickerhexval").value;
	hideColorPicker()
}